import { NextResponse as a } from "next/server";
import { CsrfError as k } from "./lib/errors.js";
import { TokenOptions as u, Config as x, createCsrfProtect as p } from "./lib/protect.js";
class f extends u {
  constructor(e) {
    super(e), this.responseHeader = "X-CSRF-Token", Object.assign(this, e);
  }
}
class d extends x {
  constructor(e) {
    super(e), this.excludePathPrefixes = ["/_next/"], this.token = new f();
    const t = e || {};
    t.token && (t.token = new f(t.token)), Object.assign(this, t);
  }
}
function h(o) {
  const e = new d(o), t = p(e);
  return async (n, r) => {
    const c = await t({
      request: n,
      url: n.nextUrl,
      getCookie: (s) => {
        var i;
        return (i = n.cookies.get(s)) == null ? void 0 : i.value;
      },
      setCookie: (s) => r.cookies.set(s)
    });
    c && r.headers.set(e.token.responseHeader, c);
  };
}
function g(o) {
  const e = h(o);
  return async (t) => {
    const n = a.next();
    try {
      await e(t, n);
    } catch (r) {
      if (r instanceof k)
        return new a("invalid csrf token", { status: 403 });
      throw r;
    }
    return n;
  };
}
export {
  d as NextConfig,
  f as NextTokenOptions,
  h as createCsrfProtect,
  g as createMiddleware
};
